{  Demonstriert wird in der Prozedur
       Ordnen durch Einsortieren
   Endgltiger Fall: Jeweils eine Hlfte wird geordnet, indem davon
                     die Hlfte geordent wird u.s.w. bis die Hlfte
                     nur noch ein Element besitzt.
   Bubblesort wird nicht mehr bentigt.
------------------------------------------------------------
   Effizienz ist von der Ordnung(n*lbn), wobei lb der Zweierlogarithmus ist
   ========================================================================
Effizienz    n       Bublesort  n^2       Hier  n*lb n
             10                100                 33
             20                400                 86
            100              10000                664
           1000           1 000 000             9 965
          10000         100 000 000           132 877
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    BFuellen: TButton;
    BOrdnen: TButton;
    EAnzahl: TEdit;
    Label1: TLabel;
    BSchliessen: TButton;
    Memo3: TMemo;
    procedure BFuellenClick(Sender: TObject);
    procedure BOrdnenClick(Sender: TObject);
    procedure BSchliessenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure Einsortieren(var aa:array of real; n1,m,n2:integer);
  //aa[n1]<=aa[n1+1]<=..<=aa[m] aa[m+1]<=aa[m+2]<=...<=aa[n2]
  //  i1------------------>     i2---------------------->
  //  k---------- fllt Hilfsfeld----------------------->
  var i1,i2,k,n:integer;
      hilf: array of real;
begin
  n:=n2-n1+1; //Anzahl von aa[n1] ... aa[n2]
  setlength(hilf,n); //Platz fr hilf[0] ... hilf[n-1]
  i1:=n1;
  i2:=m+1;
  for k:=0 to n-1 do //i1>m und i2>n2 auch abfangen!
    if (i1>m) or ((i2<=n2) and (aa[i1]>aa[i2])) then Begin
      hilf[k]:=aa[i2];
      inc(i2);
    End else  Begin
      hilf[k]:=aa[i1];
      inc(i1);
    End;
  for k:=0 to n-1 do aa[n1+k]:=hilf[k];
end;

procedure zeige(mm:Tmemo; aa:array of real);
  var i:integer;
begin
  mm.Lines.Clear;
  for i:=0 to length(aa)-1 do mm.Lines.Add(FloatToStr(aa[i]));
end;

procedure sortieren(var aa:array of real;n1,n2:integer);
  var m:integer;
begin
  if n1=n2 then exit;   //Bei einem Element ist nichts zu sortieren
  m:=(n1+n2) div 2;     //Mitte
  sortieren(aa,n1,m);   //Rekursiv
  sortieren(aa,m+1,n2); //Rekursiv
  Einsortieren(aa,n1,m,n2);
end;

procedure TForm1.BFuellenClick(Sender: TObject);
  var i,anzahl:integer;
      aa:array of real;
  procedure tausche(var a,b:real); //hier lokale Prozedur
    var x:real;
  begin
    x:=a;
    a:=b;
    b:=x;
  end;
begin
  anzahl:=strToInt(EAnzahl.text);
  setlength(aa,anzahl);
  for i:=0 to Anzahl-1 do aa[i]:=i+1;
  //Durcheinanderwirbeln
  randomize;
  for i:=0 to Anzahl-1 do tausche(aa[i],aa[random(Anzahl)]);
  zeige(memo1,aa);
end;

procedure TForm1.BOrdnenClick(Sender: TObject);
  var aa:array of real;
     n,i:integer;
begin
  n:=strToInt(EAnzahl.text);
  setlength(aa,n); //n Pltze fr aa[0] bis aa[n-1] reserviert
  for i:=0 to n-1 do aa[i]:=StrToFloat(memo1.lines[i]);
  sortieren(aa,0,length(aa)-1);
  zeige(memo3,aa);
end;

procedure TForm1.BSchliessenClick(Sender: TObject);
begin
  close
end;

end.
